Index: drivers/filesystems/btrfs/treefuncs.c
===================================================================
--- drivers/filesystems/btrfs/treefuncs.c	(révision 75772)
+++ drivers/filesystems/btrfs/treefuncs.c	(copie de travail)
@@ -1397,67 +1332,67 @@
                 }
                 break;
             }
-            
+
             case Batch_DirItem: {
                 UINT8* newdata;
-                
+
                 if (td->size + bi->datalen > maxlen) {
                     ERR("DIR_ITEM would be over maximum size (%u + %u > %u)\n", td->size, bi->datalen, maxlen);
-                    return TRUE;
+                    return STATUS_INTERNAL_ERROR;
                 }
-                
+
                 newdata = ExAllocatePoolWithTag(PagedPool, td->size + bi->datalen, ALLOC_TAG);
                 if (!newdata) {
                     ERR("out of memory\n");
-                    return TRUE;
+                    return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(newdata, td->data, td->size);
-                
+
                 RtlCopyMemory(newdata + td->size, bi->data, bi->datalen);
 
                 bi->datalen += td->size;
-                
+
                 ExFreePool(bi->data);
                 bi->data = newdata;
-                
+
                 break;
             }
-        
+
             case Batch_InodeRef: {
                 UINT8* newdata;
-                
+
                 if (td->size + bi->datalen > maxlen) {
                     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                         INODE_REF* ir = (INODE_REF*)bi->data;
                         INODE_EXTREF* ier;
-                        ULONG ierlen;
+                        UINT16 ierlen;
                         batch_item* bi2;
                         LIST_ENTRY* le;
                         BOOL inserted = FALSE;
-                        
+
                         TRACE("INODE_REF would be too long, adding INODE_EXTREF instead\n");
 
-                        ierlen = sizeof(INODE_EXTREF) - 1 + ir->n;
-                        
+                        ierlen = (UINT16)(offsetof(INODE_EXTREF, name[0]) + ir->n);
+
                         ier = ExAllocatePoolWithTag(PagedPool, ierlen, ALLOC_TAG);
                         if (!ier) {
                             ERR("out of memory\n");
-                            return TRUE;
+                            return STATUS_INSUFFICIENT_RESOURCES;
                         }
-                        
+
                         ier->dir = bi->key.offset;
                         ier->index = ir->index;
                         ier->n = ir->n;
                         RtlCopyMemory(ier->name, ir->name, ier->n);
-                        
+
                         bi2 = ExAllocateFromPagedLookasideList(&Vcb->batch_item_lookaside);
                         if (!bi2) {
                             ERR("out of memory\n");
                             ExFreePool(ier);
-                            return TRUE;
+                            return STATUS_INSUFFICIENT_RESOURCES;
                         }
-                        
+
                         bi2->key.obj_id = bi->key.obj_id;
                         bi2->key.obj_type = TYPE_INODE_EXTREF;
                         bi2->key.offset = calc_crc32c((UINT32)ier->dir, (UINT8*)ier->name, ier->n);
@@ -1464,100 +1399,101 @@
                         bi2->data = ier;
                         bi2->datalen = ierlen;
                         bi2->operation = Batch_InodeExtRef;
-                        
+
                         le = bi->list_entry.Flink;
                         while (le != listhead) {
                             batch_item* bi3 = CONTAINING_RECORD(le, batch_item, list_entry);
-                            
+
                             if (keycmp(bi3->key, bi2->key) != -1) {
                                 InsertHeadList(le->Blink, &bi2->list_entry);
                                 inserted = TRUE;
                             }
-                            
+
                             le = le->Flink;
                         }
-                        
+
                         if (!inserted)
                             InsertTailList(listhead, &bi2->list_entry);
-                        
-                        return TRUE;
+
+                        *ignore = TRUE;
+                        return STATUS_SUCCESS;
                     } else {
                         ERR("INODE_REF would be over maximum size (%u + %u > %u)\n", td->size, bi->datalen, maxlen);
-                        return TRUE;
+                        return STATUS_INTERNAL_ERROR;
                     }
                 }
-                
+
                 newdata = ExAllocatePoolWithTag(PagedPool, td->size + bi->datalen, ALLOC_TAG);
                 if (!newdata) {
                     ERR("out of memory\n");
-                    return TRUE;
+                    return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(newdata, td->data, td->size);
-                
+
                 RtlCopyMemory(newdata + td->size, bi->data, bi->datalen);
 
                 bi->datalen += td->size;
-                
+
                 ExFreePool(bi->data);
                 bi->data = newdata;
-                
+
                 break;
             }
-        
+
             case Batch_InodeExtRef: {
                 UINT8* newdata;
-                
+
                 if (td->size + bi->datalen > maxlen) {
                     ERR("INODE_EXTREF would be over maximum size (%u + %u > %u)\n", td->size, bi->datalen, maxlen);
-                    return TRUE;
+                    return STATUS_INTERNAL_ERROR;
                 }
-                
+
                 newdata = ExAllocatePoolWithTag(PagedPool, td->size + bi->datalen, ALLOC_TAG);
                 if (!newdata) {
                     ERR("out of memory\n");
-                    return TRUE;
+                    return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(newdata, td->data, td->size);
-                
+
                 RtlCopyMemory(newdata + td->size, bi->data, bi->datalen);
 
                 bi->datalen += td->size;
-                
+
                 ExFreePool(bi->data);
                 bi->data = newdata;
-                
+
                 break;
             }
-        
+
             case Batch_DeleteDirItem: {
                 if (td->size < sizeof(DIR_ITEM)) {
-                    WARN("DIR_ITEM was %u bytes, expected at least %u\n", td->size, sizeof(DIR_ITEM));
-                    return TRUE;
+                    ERR("DIR_ITEM was %u bytes, expected at least %u\n", td->size, sizeof(DIR_ITEM));
+                    return STATUS_INTERNAL_ERROR;
                 } else {
                     DIR_ITEM *di, *deldi;
                     LONG len;
-                    
+
                     deldi = (DIR_ITEM*)bi->data;
                     di = (DIR_ITEM*)td->data;
                     len = td->size;
-                    
+
                     do {
                         if (di->m == deldi->m && di->n == deldi->n && RtlCompareMemory(di->name, deldi->name, di->n + di->m) == di->n + di->m) {
-                            ULONG newlen = td->size - (sizeof(DIR_ITEM) - sizeof(char) + di->n + di->m);
-                            
+                            UINT16 newlen = td->size - (sizeof(DIR_ITEM) - sizeof(char) + di->n + di->m);
+
                             if (newlen == 0) {
                                 TRACE("deleting DIR_ITEM\n");
                             } else {
                                 UINT8 *newdi = ExAllocatePoolWithTag(PagedPool, newlen, ALLOC_TAG), *dioff;
                                 tree_data* td2;
-                                
+
                                 if (!newdi) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 TRACE("modifying DIR_ITEM\n");
 
                                 if ((UINT8*)di > td->data) {
@@ -1566,83 +1502,84 @@
                                 } else {
                                     dioff = newdi;
                                 }
-                                
-                                if ((UINT8*)&di->name[di->n + di->m] - td->data < td->size)
+
+                                if ((UINT8*)&di->name[di->n + di->m] < td->data + td->size)
                                     RtlCopyMemory(dioff, &di->name[di->n + di->m], td->size - ((UINT8*)&di->name[di->n + di->m] - td->data));
-                                
+
                                 td2 = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
                                 if (!td2) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 td2->key = bi->key;
                                 td2->size = newlen;
                                 td2->data = newdi;
                                 td2->ignore = FALSE;
                                 td2->inserted = TRUE;
-                                
+
                                 InsertHeadList(td->list_entry.Blink, &td2->list_entry);
-                                
+
                                 t->header.num_items++;
                                 t->size += newlen + sizeof(leaf_node);
                                 t->write = TRUE;
                             }
-                            
+
                             break;
                         }
-                        
+
                         len -= sizeof(DIR_ITEM) - sizeof(char) + di->n + di->m;
                         di = (DIR_ITEM*)&di->name[di->n + di->m];
-                        
+
                         if (len == 0) {
                             TRACE("could not find DIR_ITEM to delete\n");
-                            return TRUE;
+                            *ignore = TRUE;
+                            return STATUS_SUCCESS;
                         }
                     } while (len > 0);
                 }
                 break;
             }
-        
+
             case Batch_DeleteInodeRef: {
                 if (td->size < sizeof(INODE_REF)) {
-                    WARN("INODE_REF was %u bytes, expected at least %u\n", td->size, sizeof(INODE_REF));
-                    return TRUE;
+                    ERR("INODE_REF was %u bytes, expected at least %u\n", td->size, sizeof(INODE_REF));
+                    return STATUS_INTERNAL_ERROR;
                 } else {
                     INODE_REF *ir, *delir;
                     ULONG len;
                     BOOL changed = FALSE;
-                    
+
                     delir = (INODE_REF*)bi->data;
                     ir = (INODE_REF*)td->data;
                     len = td->size;
-                    
+
                     do {
-                        ULONG itemlen;
-                        
-                        if (len < sizeof(INODE_REF) || len < sizeof(INODE_REF) - 1 + ir->n) {
+                        UINT16 itemlen;
+
+                        if (len < sizeof(INODE_REF) || len < offsetof(INODE_REF, name[0]) + ir->n) {
                             ERR("INODE_REF was truncated\n");
                             break;
                         }
-                        
-                        itemlen = sizeof(INODE_REF) - sizeof(char) + ir->n;
-                        
+
+                        itemlen = (UINT16)offsetof(INODE_REF, name[0]) + ir->n;
+
                         if (ir->n == delir->n && RtlCompareMemory(ir->name, delir->name, ir->n) == ir->n) {
-                            ULONG newlen = td->size - itemlen;
-                            
+                            UINT16 newlen = td->size - itemlen;
+
                             changed = TRUE;
-                            
+
                             if (newlen == 0)
                                 TRACE("deleting INODE_REF\n");
                             else {
                                 UINT8 *newir = ExAllocatePoolWithTag(PagedPool, newlen, ALLOC_TAG), *iroff;
                                 tree_data* td2;
-                                
+
                                 if (!newir) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 TRACE("modifying INODE_REF\n");
 
                                 if ((UINT8*)ir > td->data) {
@@ -1651,32 +1588,32 @@
                                 } else {
                                     iroff = newir;
                                 }
-                                
-                                if ((UINT8*)&ir->name[ir->n] - td->data < td->size)
+
+                                if ((UINT8*)&ir->name[ir->n] < td->data + td->size)
                                     RtlCopyMemory(iroff, &ir->name[ir->n], td->size - ((UINT8*)&ir->name[ir->n] - td->data));
-                                
+
                                 td2 = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
                                 if (!td2) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 td2->key = bi->key;
                                 td2->size = newlen;
                                 td2->data = newir;
                                 td2->ignore = FALSE;
                                 td2->inserted = TRUE;
-                                
+
                                 InsertHeadList(td->list_entry.Blink, &td2->list_entry);
-                                
+
                                 t->header.num_items++;
                                 t->size += newlen + sizeof(leaf_node);
                                 t->write = TRUE;
                             }
-                            
+
                             break;
                         }
-                        
+
                         if (len > itemlen) {
                             len -= itemlen;
                             ir = (INODE_REF*)&ir->name[ir->n];
@@ -1683,58 +1620,59 @@
                         } else
                             break;
                     } while (len > 0);
-                    
+
                     if (!changed) {
                         if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                             TRACE("entry in INODE_REF not found, adding Batch_DeleteInodeExtRef entry\n");
-                            
+
                             add_delete_inode_extref(Vcb, bi, listhead);
-                            
-                            return TRUE;
+
+                            *ignore = TRUE;
+                            return STATUS_SUCCESS;
                         } else
                             WARN("entry not found in INODE_REF\n");
                     }
                 }
-                
+
                 break;
             }
-        
+
             case Batch_DeleteInodeExtRef: {
                 if (td->size < sizeof(INODE_EXTREF)) {
-                    WARN("INODE_EXTREF was %u bytes, expected at least %u\n", td->size, sizeof(INODE_EXTREF));
-                    return TRUE;
+                    ERR("INODE_EXTREF was %u bytes, expected at least %u\n", td->size, sizeof(INODE_EXTREF));
+                    return STATUS_INTERNAL_ERROR;
                 } else {
                     INODE_EXTREF *ier, *delier;
                     ULONG len;
-                    
+
                     delier = (INODE_EXTREF*)bi->data;
                     ier = (INODE_EXTREF*)td->data;
                     len = td->size;
-                    
+
                     do {
-                        ULONG itemlen;
-                        
-                        if (len < sizeof(INODE_EXTREF) || len < sizeof(INODE_EXTREF) - 1 + ier->n) {
+                        UINT16 itemlen;
+
+                        if (len < sizeof(INODE_EXTREF) || len < offsetof(INODE_EXTREF, name[0]) + ier->n) {
                             ERR("INODE_REF was truncated\n");
                             break;
                         }
-                        
-                        itemlen = sizeof(INODE_EXTREF) - sizeof(char) + ier->n;
-                        
+
+                        itemlen = (UINT16)offsetof(INODE_EXTREF, name[0]) + ier->n;
+
                         if (ier->dir == delier->dir && ier->n == delier->n && RtlCompareMemory(ier->name, delier->name, ier->n) == ier->n) {
-                            ULONG newlen = td->size - itemlen;
-                            
+                            UINT16 newlen = td->size - itemlen;
+
                             if (newlen == 0)
                                 TRACE("deleting INODE_EXTREF\n");
                             else {
                                 UINT8 *newier = ExAllocatePoolWithTag(PagedPool, newlen, ALLOC_TAG), *ieroff;
                                 tree_data* td2;
-                                
+
                                 if (!newier) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 TRACE("modifying INODE_EXTREF\n");
 
                                 if ((UINT8*)ier > td->data) {
@@ -1743,32 +1681,33 @@
                                 } else {
                                     ieroff = newier;
                                 }
-                                
-                                if ((UINT8*)&ier->name[ier->n] - td->data < td->size)
+
+                                if ((UINT8*)&ier->name[ier->n] < td->data + td->size)
                                     RtlCopyMemory(ieroff, &ier->name[ier->n], td->size - ((UINT8*)&ier->name[ier->n] - td->data));
-                                
+
                                 td2 = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
                                 if (!td2) {
                                     ERR("out of memory\n");
-                                    return TRUE;
+                                    ExFreePool(newier);
+                                    return STATUS_INSUFFICIENT_RESOURCES;
                                 }
-                                
+
                                 td2->key = bi->key;
                                 td2->size = newlen;
                                 td2->data = newier;
                                 td2->ignore = FALSE;
                                 td2->inserted = TRUE;
-                                
+
                                 InsertHeadList(td->list_entry.Blink, &td2->list_entry);
-                                
+
                                 t->header.num_items++;
                                 t->size += newlen + sizeof(leaf_node);
                                 t->write = TRUE;
                             }
-                            
+
                             break;
                         }
-                        
+
                         if (len > itemlen) {
                             len -= itemlen;
                             ier = (INODE_EXTREF*)&ier->name[ier->n];
@@ -1778,87 +1717,146 @@
                 }
                 break;
             }
-            
+
+            case Batch_DeleteXattr: {
+                if (td->size < sizeof(DIR_ITEM)) {
+                    ERR("XATTR_ITEM was %u bytes, expected at least %u\n", td->size, sizeof(DIR_ITEM));
+                    return STATUS_INTERNAL_ERROR;
+                } else {
+                    DIR_ITEM *di, *deldi;
+                    LONG len;
+
+                    deldi = (DIR_ITEM*)bi->data;
+                    di = (DIR_ITEM*)td->data;
+                    len = td->size;
+
+                    do {
+                        if (di->n == deldi->n && RtlCompareMemory(di->name, deldi->name, di->n) == di->n) {
+                            UINT16 newlen = td->size - ((UINT16)offsetof(DIR_ITEM, name[0]) + di->n + di->m);
+
+                            if (newlen == 0)
+                                TRACE("deleting XATTR_ITEM\n");
+                            else {
+                                UINT8 *newdi = ExAllocatePoolWithTag(PagedPool, newlen, ALLOC_TAG), *dioff;
+                                tree_data* td2;
+
+                                if (!newdi) {
+                                    ERR("out of memory\n");
+                                    return STATUS_INSUFFICIENT_RESOURCES;
+                                }
+
+                                TRACE("modifying XATTR_ITEM\n");
+
+                                if ((UINT8*)di > td->data) {
+                                    RtlCopyMemory(newdi, td->data, (UINT8*)di - td->data);
+                                    dioff = newdi + ((UINT8*)di - td->data);
+                                } else
+                                    dioff = newdi;
+
+                                if ((UINT8*)&di->name[di->n + di->m] < td->data + td->size)
+                                    RtlCopyMemory(dioff, &di->name[di->n + di->m], td->size - ((UINT8*)&di->name[di->n + di->m] - td->data));
+
+                                td2 = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
+                                if (!td2) {
+                                    ERR("out of memory\n");
+                                    ExFreePool(newdi);
+                                    return STATUS_INSUFFICIENT_RESOURCES;
+                                }
+
+                                td2->key = bi->key;
+                                td2->size = newlen;
+                                td2->data = newdi;
+                                td2->ignore = FALSE;
+                                td2->inserted = TRUE;
+
+                                InsertHeadList(td->list_entry.Blink, &td2->list_entry);
+
+                                t->header.num_items++;
+                                t->size += newlen + sizeof(leaf_node);
+                                t->write = TRUE;
+                            }
+
+                            break;
+                        }
+
+                        len -= sizeof(DIR_ITEM) - sizeof(char) + di->n + di->m;
+                        di = (DIR_ITEM*)&di->name[di->n + di->m];
+
+                        if (len == 0) {
+                            TRACE("could not find DIR_ITEM to delete\n");
+                            *ignore = TRUE;
+                            return STATUS_SUCCESS;
+                        }
+                    } while (len > 0);
+                }
+                break;
+            }
+
             case Batch_Delete:
                 break;
-            
+
             default:
                 ERR("unexpected batch operation type\n");
-                int3;
-                break;
+                return STATUS_INTERNAL_ERROR;
         }
-        
+
         // delete old item
         if (!td->ignore) {
-            traverse_ptr* tp2;
-            
             td->ignore = TRUE;
-        
+
             t->header.num_items--;
             t->size -= sizeof(leaf_node) + td->size;
             t->write = TRUE;
-            
-            if (rollback) {
-                tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                if (!tp2) {
-                    ERR("out of memory\n");
-                    return FALSE;
-                }
-                
-                tp2->tree = t;
-                tp2->item = td;
-    
-                add_rollback(Vcb, rollback, ROLLBACK_DELETE_ITEM, tp2);
-            }
         }
 
         if (newtd) {
             newtd->data = bi->data;
             newtd->size = bi->datalen;
-            InsertHeadList(&td->list_entry, &newtd->list_entry);
+            InsertHeadList(td->list_entry.Blink, &newtd->list_entry);
         }
     } else {
         ERR("(%llx,%x,%llx) already exists\n", bi->key.obj_id, bi->key.obj_type, bi->key.offset);
-        int3;
+        return STATUS_INTERNAL_ERROR;
     }
-    
-    return FALSE;
+
+    *ignore = FALSE;
+    return STATUS_SUCCESS;
 }
 
-static void commit_batch_list_root(device_extension* Vcb, batch_root* br, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS commit_batch_list_root(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, batch_root* br, PIRP Irp) {
     LIST_ENTRY* le;
     NTSTATUS Status;
-    
+
     TRACE("root: %llx\n", br->r->id);
-    
+
     le = br->items.Flink;
     while (le != &br->items) {
         batch_item* bi = CONTAINING_RECORD(le, batch_item, list_entry);
-        LIST_ENTRY *le2, *listhead;
-        traverse_ptr tp, *tp2;
+        LIST_ENTRY *le2;
+        traverse_ptr tp;
         KEY tree_end;
         BOOL no_end;
-        tree_data* td;
+        tree_data *td, *listhead;
         int cmp;
         tree* t;
         BOOL ignore = FALSE;
-        
+
         TRACE("(%llx,%x,%llx)\n", bi->key.obj_id, bi->key.obj_type, bi->key.offset);
-        
-        Status = find_item(Vcb, br->r, &tp, &bi->key, FALSE, Irp);
+
+        Status = find_item(Vcb, br->r, &tp, &bi->key, TRUE, Irp);
         if (!NT_SUCCESS(Status)) { // FIXME - handle STATUS_NOT_FOUND
             ERR("find_item returned %08x\n", Status);
-            return;
+            return Status;
         }
-        
+
         find_tree_end(tp.tree, &tree_end, &no_end);
-        
+
         if (bi->operation == Batch_DeleteInode) {
             if (tp.item->key.obj_id == bi->key.obj_id) {
                 BOOL ended = FALSE;
-                
+
                 td = tp.item;
-                
+
                 if (!tp.item->ignore) {
                     tp.item->ignore = TRUE;
                     tp.tree->header.num_items--;
@@ -1865,11 +1863,11 @@
                     tp.tree->size -= tp.item->size + sizeof(leaf_node);
                     tp.tree->write = TRUE;
                 }
-                
+
                 le2 = tp.item->list_entry.Flink;
                 while (le2 != &tp.tree->itemlist) {
                     td = CONTAINING_RECORD(le2, tree_data, list_entry);
-                    
+
                     if (td->key.obj_id == bi->key.obj_id) {
                         if (!td->ignore) {
                             td->ignore = TRUE;
@@ -1881,24 +1879,24 @@
                         ended = TRUE;
                         break;
                     }
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 while (!ended) {
                     traverse_ptr next_tp;
-                    
+
                     tp.item = td;
-                    
+
                     if (!find_next_item(Vcb, &tp, &next_tp, FALSE, Irp))
                         break;
-                    
+
                     tp = next_tp;
-                    
+
                     le2 = &tp.item->list_entry;
                     while (le2 != &tp.tree->itemlist) {
                         td = CONTAINING_RECORD(le2, tree_data, list_entry);
-                        
+
                         if (td->key.obj_id == bi->key.obj_id) {
                             if (!td->ignore) {
                                 td->ignore = TRUE;
